unit LevelEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, Menus, ExtCtrls, Paga, StdCtrls;

const BilderMax=29;

type
  TPagaEditor = class(TForm)
    Eingabe: TDrawGrid;
    BildSchlangeL: TImage;
    BildWasser: TImage;
    BildDiamant: TImage;
    BildALLinksO: TImage;
    BildStein: TImage;
    BildErde: TImage;
    BildFels: TImage;
    BildMauerstein: TImage;
    BildKey: TImage;
    BildTor: TImage;
    BildRohrW: TImage;
    BildSpeer: TImage;
    BildALRechtsO: TImage;
    BildLeer: TImage;
    BildSchalter: TImage;
    BildMauer: TImage;
    BildGranit: TImage;
    BildRohrS: TImage;
    BildRohrWOL: TImage;
    BildRohrWUL: TImage;
    BildRohrWOR: TImage;
    BildRohrWUR: TImage;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Laden: TMenuItem;
    Speichern: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    Neu: TMenuItem;
    Auswahl: TImage;
    LabelA: TLabel;
    DateiSpeichern: TSaveDialog;
    DateiLesen: TOpenDialog;
    LabelL: TLabel;
    BildSpinneR: TImage;
    BildSpinneU: TImage;
    BildSpinneL: TImage;
    BildSpinneO: TImage;
    BildBeamer: TImage;
    BildZusatzDiamant: TImage;
    BildInschrift: TImage;
    Tips: TMenuItem;
    BeamerSet: TRadioGroup;
    BeamerClear: TRadioGroup;
    MemoHinweise: TMemo;
    Label1: TLabel;
    procedure BeamerClearClick(Sender: TObject);
    procedure BeamerSetClick(Sender: TObject);
    procedure TipsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EingabeMouseDown(Sender: TObject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
    procedure NeuClick(Sender: TObject);
    procedure FigurClick(Sender: TObject);
    procedure EingabeDrawCell(Sender: TObject; ACol, ARow: Integer;Rect: TRect;
                              State: TGridDrawState);
    procedure SpeichernClick(Sender: TObject);
    procedure LadenClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Muster:TFeld;
    Bilder:Array[0..BilderMax]of Record Name:String;Wert:Integer;end;
    BeamerListe:Array[1..BeamerMax]of Record Von,Nach:TPoint;end; // Beamerliste
    Inhalt:Integer;
    procedure Umwandeln;
  public
    { Public-Deklarationen }
  end;

var PagaEditor: TPagaEditor;
    

implementation

uses EditorRegeln;


{$R *.dfm}
{$R+,Q+}

 procedure TPagaEditor.FormCreate(Sender: TObject);
  var Jahr,Monat,Tag:Word;
      Wer:String;
  begin
   Paganitzu.CopyRightName(Wer);
   DecodeDate(Now,Jahr,Monat,Tag);
   Caption:='LevelEditor fr Paganitzu - Die Suche nach der Diamantrose  '+IntToStr(Jahr)+'   '+Wer;
   Bilder[0].Name:='Leer';Bilder[0].Wert:=Leer;
   Bilder[1].Name:='SchlangeL';Bilder[1].Wert:=Schlange;
   Bilder[2].Name:='Wasser';Bilder[2].Wert:=Wasser;
   Bilder[3].Name:='Diamant';Bilder[3].Wert:=Diamant;
   Bilder[4].Name:='Schalter';Bilder[4].Wert:=Schalter;
   Bilder[5].Name:='ALLinksO';Bilder[5].Wert:=ALL;
   Bilder[6].Name:='Stein';Bilder[6].Wert:=Stein;
   Bilder[7].Name:='Erde';Bilder[7].Wert:=Erde;
   Bilder[8].Name:='Fels';Bilder[8].Wert:=Fels;
   Bilder[9].Name:='Mauerstein';Bilder[9].Wert:=Mauerstein;
   Bilder[10].Name:='Key';Bilder[10].Wert:=Schluessel;
   Bilder[11].Name:='Tor';Bilder[11].Wert:=Tor;
   Bilder[12].Name:='RohrW';Bilder[12].Wert:=RohrW;
   Bilder[13].Name:='Speer';Bilder[13].Wert:=Speer;
   Bilder[14].Name:='Mauer';Bilder[14].Wert:=Mauer;
   Bilder[15].Name:='Granit';Bilder[15].Wert:=Granit;
   Bilder[16].Name:='RohrS';Bilder[16].Wert:=RohrS;
   Bilder[17].Name:='RohrWOL';Bilder[17].Wert:=RohrWOL;
   Bilder[18].Name:='RohrWUL';Bilder[18].Wert:=RohrWUL;
   Bilder[19].Name:='RohrWOR';Bilder[19].Wert:=RohrWOR;
   Bilder[20].Name:='RohrWUR';Bilder[20].Wert:=RohrWUR;
   Bilder[21].Name:='ALTodAsche';Bilder[21].Wert:=Tod;
   Bilder[22].Name:='ALRechtsO';Bilder[22].Wert:=ALR;
   Bilder[23].Name:='SpinneO';Bilder[23].Wert:=Spinne1;
   Bilder[24].Name:='SpinneR';Bilder[24].Wert:=Spinne2;
   Bilder[25].Name:='SpinneU';Bilder[25].Wert:=Spinne3;
   Bilder[26].Name:='SpinneL';Bilder[26].Wert:=Spinne4;
   Bilder[27].Name:='ZusatzDiamant';Bilder[27].Wert:=ZusatzDiamant;
   Bilder[28].Name:='Beamer';Bilder[28].Wert:=SZ1;
   Bilder[29].Name:='Inschrift';Bilder[29].Wert:=Inschrift;
   NeuClick(Self);
   Inhalt:=ALL;
  end;

 procedure TPagaEditor.EingabeMouseDown(Sender: TObject; Button: TMouseButton;
                                        Shift: TShiftState; X, Y: Integer);
  var ACol,ARow,Index:Integer;
      Fertig:Boolean;
  begin
   Eingabe.MouseToCell(X,Y,ACol,ARow);
   Fertig:=False;
   if Inhalt=SZ1 then
    if BeamerSet.ItemIndex>0 then
     begin
      Index:=BeamerSet.ItemIndex;
      if BeamerListe[Index].Von.X=-1 then // gelscht
       begin
        BeamerListe[Index].Von.X:=ACol;
        BeamerListe[Index].Von.Y:=ARow;
       end
      else
       begin
        BeamerListe[Index].Nach.X:=ACol;
        BeamerListe[Index].Nach.Y:=ARow;
       end;
      if (BeamerListe[Index].Von.X>-1) and (BeamerListe[Index].Nach.X>-1) then
       begin
        BildBeamer.Enabled:=False;
        BeamerSet.ItemIndex:=0; // setzen zuende
        BeamerSet.Buttons[Index].Enabled:=False; // Beamer sperren
        BeamerClear.Buttons[Index].Enabled:=True; // Beamer zum Lschen freigeben
        inc(Index);if Index>BeamerMax then Index:=1;
        BeamerSet.Buttons[Index].Enabled:=True; // nchster Beamer zum Setzen
        Fertig:=True;
       end;
     end;
   if Inhalt=Leer then
    for Index:=1 to BeamerMax do
     if ((BeamerListe[Index].Von.X=ACol) and (BeamerListe[Index].Von.Y=ARow)) or
        ((BeamerListe[Index].Nach.X=ACol)and (BeamerListe[Index].Nach.Y=ARow)) then
      begin
       MessageDlg('So kannst du keinen Beamer lschen!!!',mtError,[mbRetry],0);
       exit;
      end;
   Muster[ACol,ARow]:=Inhalt;
   Eingabe.Canvas.Draw(41*x,41*y,Auswahl.Picture.Bitmap);
   if Fertig then
    begin
     Inhalt:=ALL;
     Auswahl.Picture:=BildALLinksO.Picture;
    end;
  end;

 procedure TPagaEditor.NeuClick(Sender: TObject);
  var K:Integer;
  begin
   FillChar(Muster,SizeOf(Muster),Leer);
   FillChar(BeamerListe,SizeOf(BeamerListe),-1); // Beamerliste lschen
   Eingabe.Repaint;
   MemoHinweise.Clear;
   for K:=0 to BeamerMax do
    begin
     BeamerSet.Buttons[K].Cursor:=crHandPoint;
     if K>1 then BeamerSet.Buttons[K].Enabled:=False
     else BeamerSet.Buttons[K].Enabled:=True;
     if K>0 then BeamerClear.Buttons[K].Enabled:=False
     else BeamerClear.Buttons[K].Enabled:=True;
     BeamerClear.Buttons[K].Cursor:=crHandPoint;
    end;
  end;

 procedure TPagaEditor.FigurClick(Sender: TObject);
  var K,Nr:Integer;
  begin
   Inhalt:=0;
   for K:=0 to BilderMax do
    if Sender=TImage(FindComponent('Bild'+Bilder[K].Name)) then Nr:=K;
   Auswahl.Picture:=TImage(FindComponent('Bild'+Bilder[Nr].Name)).Picture;
   if Nr>=0 then Inhalt:=Bilder[Nr].Wert;
  end;

 procedure TPagaEditor.BeamerClearClick(Sender: TObject);
  var Index,K,L:Integer;
  begin
   if BeamerClear.ItemIndex>0 then
    begin
     Index:=BeamerClear.ItemIndex;
     if (BeamerListe[Index].Von.X=-1) and (BeamerListe[Index].Nach.X=-1) then
      MessageDlg('Es gibt NICHTS zu lschen!!!',mtError,[mbRetry],0)
     else
      begin
       if MessageDlg('Soll Beamer '+IntToStr(Index)+' wirklich gelscht werden?',mtConfirmation,[mbYes,mbNo],0)=mrNo then
        begin
         MessageDlg('Beamer '+IntToStr(Index)+' wird NICHT gelscht!!!',mtInformation,[mbOk],0);
         exit;
        end;
       Muster[BeamerListe[Index].Von.X,BeamerListe[Index].Von.Y]:=Leer;
       Muster[BeamerListe[Index].Nach.X,BeamerListe[Index].Nach.Y]:=Leer;
       BeamerListe[Index].Von.X:=-1;
       BeamerListe[Index].Von.Y:=-1;
       BeamerListe[Index].Nach.X:=-1;
       BeamerListe[Index].Nach.Y:=-1;
       MessageDlg('Beamer '+IntToStr(Index)+' ist gelscht!!!',mtInformation,[mbOk],0);
       Eingabe.Repaint;
       BeamerClear.Buttons[Index].Enabled:=False;
       BeamerSet.Buttons[Index].Enabled:=True;
       for K:=1 to BeamerMax do
        if BeamerSet.Buttons[K].Enabled then
         for L:=K+1 to BeamerMax do
          BeamerSet.Buttons[L].Enabled:=False;
      end;
     BeamerClear.ItemIndex:=0; // lschen zuende
    end;
  end;

 procedure TPagaEditor.BeamerSetClick(Sender: TObject);
  begin
   if BeamerSet.ItemIndex>0 then BildBeamer.Enabled:=True
   else BildBeamer.Enabled:=False;
  end;

 procedure TPagaEditor.EingabeDrawCell(Sender: TObject; ACol, ARow: Integer;
                                       Rect: TRect; State: TGridDrawState);
  var Wert,K:Integer;
  begin
   Wert:=Muster[ACol,ARow];
   if Wert>ZusatzDiamant then Wert:=Wert-ZusatzDiamant;
   Eingabe.Canvas.Draw(41*ACol,41*ARow,Paganitzu.Bild[Wert]);
   for K:=1 to BeamerMax do
    if ((BeamerListe[K].Von.X=ACol) and (BeamerListe[K].Von.Y=ARow))or
       ((BeamerListe[K].Nach.X=ACol)and (BeamerListe[K].Nach.Y=ARow)) then
     with Eingabe.Canvas do
      begin
       Brush.Color:=clBlack;
       Font.Color:=clWhite;
       Font.Style:=[fsBold];
       Font.Size:=6;
       TextOut(Rect.Left+2,Rect.Top+2,IntToStr(K));
      end;
  end;

 procedure TPagaEditor.SpeichernClick(Sender: TObject);
//                                           Spinnen, Zusatzdiamant, Beamer,
  const Zeichen=' SWD#)*EFMKT=^+G|;,:.?(??????I???1234zabcdefghijkl';
  var K,x,y,DateiNr,BeamerAnzahl:Integer;
      Zeile:String;
  begin
   for K:=1 to BeamerMax do
   //         gesetzt                      ungesetzt
    if (BeamerListe[K].Von.X>-1) and (BeamerListe[K].Nach.X=-1) then
     begin
      MessageDlg('Es fehlt ein Beamer bei Paar '+IntToStr(K)+' !!!',mtError,[mbRetry],0);
      exit;
     end;
   BeamerAnzahl:=0;
   for K:=1 to BeamerMax do
    if BeamerListe[K].Von.X>-1 then // beamer setzen
     begin
      inc(BeamerAnzahl);
      Muster[BeamerListe[K].Von.X,BeamerListe[K].Von.Y]:=BeamerAnzahl+ZusatzDiamant;
      Muster[BeamerListe[K].Nach.X,BeamerListe[K].Nach.Y]:=BeamerAnzahl+ZusatzDiamant;
     end;
   Paganitzu.LevelMuster.Clear;
   for y:=0 to Lang do
    begin
     Zeile:='';
     for x:=0 to Breit do Zeile:=Zeile+Zeichen[Muster[x,y]+1];
     Paganitzu.LevelMuster.Add(Zeile);
    end;
   // Hinweise zum Level
   for K:=0 to MemoHinweise.Lines.Count-1 do
    Paganitzu.LevelMuster.Add(MemoHinweise.Lines[K]);
   with DateiSpeichern do
    begin
     ForceCurrentDirectory:=True;
     Filter:='Paganitzudateien (*.lev) |*.lev';
     DefaultExt:='lev';
     Options:=[ofOverwritePrompt]; // Sicherheitsabfrage wegen berschreibens
     if Execute then
      begin
       // codieren
       try
        DateiNr:=DateTimeToFileDate(Now);
        RandSeed:=DateiNr;
        for K:=0 to Paganitzu.LevelMuster.Count-1 do
         begin
          Zeile:=Paganitzu.LevelMuster[K];
          Paganitzu.Codieren(Zeile,1); // verschlsseln
          Paganitzu.LevelMuster[K]:=Zeile;
         end;
        Paganitzu.LevelMuster.SaveToFile(FileName);
        if FileSetDate(FileName,DateiNr)<>0 then
         MessageDlg('Fehler beim Speichern der Datei '+FileName+'!',mtError,[mbOk],0)
        else MessageDlg('gespeichert wurde '+FileName,mtInformation,[mbOk],0);
       except
         MessageDlg('Datei '+FileName+' kann nicht gespeichert werden!',mtError,[mbOk],0);
        end;
      end
    end;
   // Feld wiederherstellen
   for K:=1 to BeamerMax do
    if BeamerListe[K].Von.X>-1 then // beamer setzen
     begin
      Muster[BeamerListe[K].Von.X,BeamerListe[K].Von.Y]:=SZ1;
      Muster[BeamerListe[K].Nach.X,BeamerListe[K].Nach.Y]:=SZ1;
     end;
   Eingabe.Repaint; 
  end;

 procedure TPagaEditor.TipsClick(Sender: TObject);
  begin
   EditorBox.ShowModal;
  end;

 procedure TPagaEditor.LadenClick(Sender: TObject);
  var K,DateiNr:Integer;
      Zeile:String;
  begin
   with DateiLesen do
    begin
     ForceCurrentDirectory:=True;
     Filter:='Paganitzudateien (*.lev) |*.lev';
     DefaultExt:='lev';
     if Execute then
      begin
       Paganitzu.LevelMuster.LoadFromFile(FileName);
       LabelL.Caption:=ExtractFileName(FileName);
       // entschlsseln
       DateiNr:=FileAge(FileName);
       RandSeed:=DateiNr;
       for K:=0 to Paganitzu.LevelMuster.Count-1 do
        begin
         Zeile:=Paganitzu.LevelMuster[K];
         Paganitzu.Codieren(Zeile,-1); // entschlsseln
         Paganitzu.LevelMuster[K]:=Zeile;
        end;
       Umwandeln;
       Eingabe.Repaint;
      end
    end
  end;

 procedure TPagaEditor.Umwandeln;
  var x,y,Index,K:Integer;
      Zeile:String;
      Zeichen:Char;
  begin
   FillChar(Muster,SizeOf(Muster),Leer);
   FillChar(BeamerListe,SizeOf(BeamerListe),-1); // Beamerliste lschen
   BeamerSet.Buttons[0].Enabled:=True;
   BeamerClear.Buttons[0].Enabled:=True;
   for K:=1 to BeamerMax do
    begin
     BeamerSet.Buttons[K].Enabled:=False;
     BeamerClear.Buttons[K].Enabled:=False;
    end;
   K:=0;
   for y:=0 to Lang do
    begin
     Zeile:=Paganitzu.LevelMuster[y];
     for x:=0 to Length(Zeile)-1 do
      begin
       Zeichen:=Zeile[x+1];
       case Zeichen of
        ')' : Muster[x,y]:=ALL;
        '(' : Muster[x,y]:=ALR;
        'W' : Muster[x,y]:=Wasser;
        '+' : Muster[x,y]:=Mauer;
        'T' : Muster[x,y]:=Tor;
        '*' : Muster[x,y]:=Stein;
        '=' : Muster[x,y]:=RohrW;
        'E' : Muster[x,y]:=Erde;
        'S' : Muster[x,y]:=Schlange;
        '#' : Muster[x,y]:=Schalter;
        'D' : Muster[x,y]:=Diamant;
        'K' : Muster[x,y]:=Schluessel;
        'F' : Muster[x,y]:=Fels;
        'G' : Muster[x,y]:=Granit;
        '^' : Muster[x,y]:=Speer;
        'M' : Muster[x,y]:=Mauerstein;
        '|' : Muster[x,y]:=RohrS;
        ';' : Muster[x,y]:=RohrWOL;
        ',' : Muster[x,y]:=RohrWUL;
        ':' : Muster[x,y]:=RohrWOR;
        '.' : Muster[x,y]:=RohrWUR;
        '1' : Muster[x,y]:=Spinne1;
        '2' : Muster[x,y]:=Spinne2;
        '3' : Muster[x,y]:=Spinne3;
        '4' : Muster[x,y]:=Spinne4;
        'z' : Muster[x,y]:=ZusatzDiamant;
        'I' : Muster[x,y]:=Inschrift;
        'a'..'l': begin
                   Muster[x,y]:=SZ1;
                   Index:=ord(Zeichen)-ord('a')+1;
                   if K<Index then K:=Index;
                   BeamerClear.Buttons[Index].Enabled:=True;
                   if BeamerListe[Index].Von.X=-1 then // undefiniert
                    begin
                     BeamerListe[Index].Von.X:=x;
                     BeamerListe[Index].Von.Y:=y;
                    end
                   else
                    begin
                     BeamerListe[Index].Nach.X:=x;
                     BeamerListe[Index].Nach.Y:=y;
                    end
                  end;
       end;
      end;
    end;
   if K<BeamerMax then
    BeamerSet.Buttons[K+1].Enabled:=True;
   MemoHinweise.Clear;
   for y:=Lang+1 to Paganitzu.LevelMuster.Count-1 do
    MemoHinweise.Lines.Add(Paganitzu.LevelMuster[y]);
  end;

end.

